%global with_doc %{!?_without_doc:1}%{?_without_doc:0}
%global git_snaptag 1589
%global git_commit g1d6372f

%{!?upstream_version:   %global upstream_version         %{version}.dev%{git_snaptag}.%{git_commit}}

# openstack-packstack ----------------------------------------------------------

Name:           openstack-packstack
Version:        2015.1
Release:        0.20.dev%{git_snaptag}.%{git_commit}%{?dist}
Summary:        Openstack Install Utility

Group:          Applications/System
License:        ASL 2.0 and GPLv2
URL:            https://github.com/stackforge/packstack
# Tarball is created by bin/release.sh
Source0:        http://mmagr.fedorapeople.org/downloads/packstack/packstack-%{upstream_version}.tar.gz

#patches_base=1d6372f+1
#patches_ignore=DROP-IN-RPM
Patch0001: 0001-Set-LBaaS-FWaaS-classes-before-neutron-class.patch
Patch0002: 0002-Don-t-run-fwaas-lbaas-classes-on-standalone-api-node.patch
Patch0003: 0003-Sync-DB-when-neutron-service-is-enabled.patch
Patch0004: 0004-resolve-coding-error-to-fix-user-supplied-certs.patch
Patch0005: 0005-Hostname-support.patch
Patch0006: 0006-Fix-keystonerc_demo-file-generation.patch
Patch0007: 0007-Added-Neutron-VPNaaS.patch
Patch0008: 0008-Make-runs-reproducible-when-using-answer-file.patch
Patch0009: 0009-Add-symlink-to-support-hiera-3.0.patch
Patch0010: 0010-Dashboard-s-local_settings-file-should-not-be-world-.patch
Patch0011: 0011-etc-rabbitmq-rabbitmq.config-should-not-be-world-rea.patch
Patch0012: 0012-Fix-IPv6.patch
Patch0013: 0013-Fixes-interface-character-processing.patch
Patch0014: 0014-Add-notification-driver.patch
Patch0015: 0015-Adjust-live-migration-config-to-changes-in-puppet-no.patch

BuildArch:      noarch

BuildRequires:  python2-devel
BuildRequires:  python-setuptools

Requires:       openssh-clients
Requires:       python-netaddr
Requires:       openstack-packstack-puppet == %{version}-%{release}
Requires:       openstack-puppet-modules >= 2014.2.10
Obsoletes:      packstack-modules-puppet
Requires:       python-setuptools
Requires:       PyYAML
Requires:       python-docutils
Requires:       python-ldap
Requires:       pyOpenSSL

%description
Packstack is a utility that uses Puppet modules to install OpenStack. Packstack
can be used to deploy various parts of OpenStack on multiple pre installed
servers over ssh.


# openstack-packstack-puppet ---------------------------------------------------

%package puppet
Summary:        Packstack Puppet module
Group:          Development/Libraries

%description puppet
Puppet module used by Packstack to install OpenStack


# openstack-packstack-doc ------------------------------------------------------

%if 0%{?with_doc}
%package doc
Summary:          Documentation for Packstack
Group:            Documentation

%if 0%{?rhel} == 6
BuildRequires:  python-sphinx10
%else
BuildRequires:  python-sphinx
%endif

%description doc
This package contains documentation files for Packstack.
%endif


# prep -------------------------------------------------------------------------

%prep
%setup -n packstack-%{upstream_version} -q

%patch0001 -p1
%patch0002 -p1
%patch0003 -p1
%patch0004 -p1
%patch0005 -p1
%patch0006 -p1
%patch0007 -p1
%patch0008 -p1
%patch0009 -p1
%patch0010 -p1
%patch0011 -p1
%patch0012 -p1
%patch0013 -p1
%patch0014 -p1
%patch0015 -p1

# Sanitizing a lot of the files in the puppet modules
find packstack/puppet/modules \( -name .fixtures.yml -o -name .gemfile -o -name ".travis.yml" -o -name .rspec \) -exec rm {} +
find packstack/puppet/modules \( -name "*.py" -o -name "*.rb" -o -name "*.pl" \) -exec sed -i '/^#!/{d;q}' {} + -exec chmod -x {} +
find packstack/puppet/modules \( -name "*.sh" \) -exec sed -i 's/^#!.*/#!\/bin\/bash/g' {} + -exec chmod +x {} +
find packstack/puppet/modules -name site.pp -size 0 -exec rm {} +
find packstack/puppet/modules \( -name spec -o -name ext \) | xargs rm -rf

# Moving this data directory out temporarily as it causes setup.py to throw errors
rm -rf %{_builddir}/puppet
mv packstack/puppet %{_builddir}/puppet


# build ------------------------------------------------------------------------

%build
%{__python} setup.py build

%if 0%{?with_doc}
cd docs
%if 0%{?rhel} == 6
make man SPHINXBUILD=sphinx-1.0-build
%else
make man
%endif
%endif


# install ----------------------------------------------------------------------

%install
%{__python} setup.py install --skip-build --root %{buildroot}

# Delete tests
rm -fr %{buildroot}%{python_sitelib}/tests

# Install Puppet module
mkdir -p %{buildroot}/%{_datadir}/openstack-puppet/modules
cp -r %{_builddir}/puppet/modules/packstack  %{buildroot}/%{_datadir}/openstack-puppet/modules/

# Move packstack documentation
mkdir -p %{buildroot}/%{_datadir}/packstack
install -p -D -m 644 docs/packstack.rst %{buildroot}/%{_datadir}/packstack

# Move Puppet manifest templates back to original place
mkdir -p %{buildroot}/%{python_sitelib}/packstack/puppet
mv %{_builddir}/puppet/templates %{buildroot}/%{python_sitelib}/packstack/puppet/

%if 0%{?with_doc}
mkdir -p %{buildroot}%{_mandir}/man1
install -p -D -m 644 docs/_build/man/*.1 %{buildroot}%{_mandir}/man1/
%endif

# Remove docs directory
rm -fr %{buildroot}%{python_sitelib}/docs

# files ------------------------------------------------------------------------

%files
%doc LICENSE
%{_bindir}/packstack
%{_datadir}/packstack
%{python_sitelib}/packstack
%{python_sitelib}/packstack-*.egg-info

%files puppet
%defattr(644,root,root,755)
%{_datadir}/openstack-puppet/modules/packstack

%if 0%{?with_doc}
%files doc
%{_mandir}/man1/packstack.1.gz
%endif


# changelog --------------------------------------------------------------------

%changelog
* Thu Jun 1 2017 Alfredo Moralejo <amoralej@redhat.com> - 2015.1-0.20.dev1589.g1d6372f
- Adjust live migration config to changes in puppet-nova (rhbz#1457265)

* Mon Sep 19 2016 Iván Chavero <ichavero@redhat.com> - 2015.1-0.19.dev1589.g1d6372f
- Add 0014-Add-notification-driver.patch (rhbz#1299563)

* Tue Aug 02 2016 Iván Chavero <ichavero@redhat.com> - 2015.1-0.18.dev1589.g1d6372f
- Add 0013-Fixes-interface-character-processing.patch (rhbz#1335595)

* Sat Mar 19 2016 Iván Chavero <ichavero@redhat.com> - 2015.1-0.17.dev1589.g1d6372f
- Add pyOpenSSL dependency (rhbz#1313764)

* Tue Feb 02 2016 Martin Mágr <mmagr@redhat.com> - 2015.1-0.16.dev1589.g1d6372f
- [Swift] Added 0012-Fix-IPv6.patch (rhbz#1294659)

* Thu Dec 10 2015 Iván Chavero <ichavero@redhat.com> - 2015.1-0.15.dev1589.g1d6372f
- [Keystone] Added 0006-Fix-keystonerc_demo-file-generation.patch (rhbz#1236229)
- [Neutron] 0007-Added-Neutron-VPNaaS.patch (rhbz#1136332)
- [Packstack] 0008-Make-runs-reproducible-when-using-answer-file.patch (rhbz#1270243)
- [Puppet] 0009-Add-symlink-to-support-hiera-3.0.patch (rhbz#1288806)
- [Horizon] 0010-Dashboard-s-local_settings-file-should-not-be-world-.patch (rhbz#1217089)
- [Rabbitmq] 0011-etc-rabbitmq-rabbitmq.config-should-not-be-world-rea.patch (rhbz#1218817)

* Fri Nov 20 2015 Iván Chavero <ichavero@redhat.com> - 2015.1-0.14.dev1589.g1d6372f
- Added python-ldap as dependency to spec file (rhbz#1205506)

* Thu Nov 05 2015 Martin Mágr <ichavero@redhat.com> - 2015.1-0.13.dev1589.g1d6372f
- Added 0005-Hostname-support.patch (rhbz#1129773)

* Tue Sep 22 2015 Iván Chavero <ichavero@redhat.com> - 2015.1-0.12.dev1589.g1d6372f
- Add [Horizon] 0004-Horizon-SSL-resolve-coding-error-to-fix-user-supplie.patch (rhbz#1243949)

* Tue Jul 21 2015 Lon Hohberger <lon@redhat.com> - 2015.1-0.11.dev1589.g1d6372f
- Rebuild

* Mon Jul 20 2015 Iván Chavero <ichavero@redhat.com> - 2015.1-0.10.dev1589.g1d6372f
- Revert previous unapproved changes
- [Neutron] Sync DB when neutron service is enabled (rhbz#1230199)

* Mon Jul 20 2015 Iván Chavero <ichavero@redhat.com> - 2015.1-0.9.dev1608.g6447ff7
- [Neutron] Sync DB when neutron service is enabled (rhbz#1230199)
- [Packstack] Spellchecking cleanup in prescript_000.py "pre installing"
- [Cinder] Cinder NetApp 7-mode FC configuration
- [Neutron] Set LBaaS/FWaaS classes before neutron class
- [Neutron] Don't run fwaas/lbaas classes on standalone api nodes (rhbz#1233149)
- [Horizon] [SSL] resolve coding error to fix user supplied certs (lp#1475170)
- Remove 0001-Set-LBaaS-FWaaS-classes-before-neutron-class.patch
- Remove 0002-Neutron-Don-t-run-fwaas-lbaas-classes-on-standalone-.patch

* Fri Jul 17 2015 Lukas Bezdicka <lbezdick@redhat.com> - 2015.1-0.8.dev1589.g1d6372f
- [Neutron] deliver patches for rhbz#1230199

* Tue Jun 30 2015 Gaël Chamoulaud <gchamoul@redhat.com> - 2015.1-0.7.dev1589.g1d6372f
- [Keystone] Fix double slash in adminUrl - rhbz#1232343
- [Manila] Make sure Manila always run after Glance
- [Packstack] Spelling correction for typo in prescript_ooo.py
- [Packstack] Fix answer file duplicate values
- [Sahara] Fix sahara template for qpid
- [Neutron] Fix linuxbridge and switch it to ml2 plugin

* Mon Jun 22 2015 Jon Schlueter <jschluet@redhat.com> - 2015.1-0.6.dev1577.gc9f8c3c
- updating version number and change log version numbers
- quiet the setup phase

* Mon Jun 22 2015 Iván Chavero <ichavero@redhat.com> - 2015.1-0.4.dev1577.gc9f8c3c
- [AMQP] ensure nssdb pw is set to undef if we don't use ssl - rhbz#1232648
- [Nagios] Fix 'File mode must be a string, not "Fixnum"' error
- [Cinder] set correct backup_swift_url - rhbz#1232198
- [Packstack] Depend on package resource names
- [Horizon] ensure horizon secret key stays same
- [Nagios] rework packstack nagios puppet generation
- [Neutron] Fix br-ext IP configuration

* Tue Jun 09 2015 Iván Chavero <ichavero@redhat.com> - 2015.1-0.3.dev1565.gd1211af
- [Neutron] use correct iface addresses on tunnel firewall rules - rhbz#1215638
- [Apache] don't purge apache configs in prescript
- [Apache] Fix apache module issues
- [Packstack] Updated LDAP doc entries
- [Packstack] Base force_interface on ipaddr instead of ipaddress
- [Packstack] Add symbolic link for latest log dir
- [Heat] Add processor process_string_nofloat
- [Nova] Fix Nova Networking with Manila Generic Driver
- [Nova] Fix instance metadata when not installing neutron
- [Swift] temporary use ipv6 address without brackets
- [memcached] fix memory consumption and add temporary IPv6 hack
- [Provision] re-enable provisioning subnets with ipv6
- [Keystone] Unite keystone admin and public url configuration
- [SSL] fix validate_writeable_directory
- [KEYSTONE] Correctly switch all admin usernames to CONFIG_KEYSTONE_ADMIN_USERNAME
- [Packstack] Refactor SSL setup to use CA to sign certificates
- [Neutron] Correct value of $public_bridge_name
- [Packstack] Add ability to enable rdo testing repo
- [Neutron] Allow CIDR instead of iterface name
- [Mongodb] Fix mongodb configuration

* Thu May 07 2015 Lon Hohberger <lon@redhat.com> - 2015.1-0.2.dev1537.gba5183c
- Always use proper config file for mongodb

* Sat May 02 2015 Alan Pevec <apevec@redhat.com> - 2015.1-0.1.dev1537.gba5183c
- Kilo release

* Mon Feb 23 2015 Martin Mágr <mmagr@redhat.com> - 2015.1-0.1.dev1484.g9bd9178
- Initial Kilo build
